/*
$Id: r_c.h,v 1.1.1.1 1998/07/21 10:27:53 rene Exp $
*/
#ifndef F2C_C_H
#define F2C_C_H

#define __FGL2C__
#ifndef FGLLANG
#define FGLLANG
#endif

#ifndef FGLDEC
#define FGLDEC
typedef struct decimal dec_t;
#endif
typedef struct Datetime dtime_t;
typedef struct Interval intrvl_t;

FGLLANG void fgl_fatal(const char*f,int l,int n);

FGLLANG void popdate(long *dst);
FGLLANG void popint(int *);
FGLLANG void popshort(short *);
FGLLANG void poplong(long *);
FGLLANG void popflo(float *);
FGLLANG void popdub(double *);
FGLLANG void popdec(dec_t *);
FGLLANG void popquote(char*,int len);
FGLLANG void popvchar(char*,int len);
FGLLANG void popdtime(dtime_t*,int size);

FGLLANG void retdate(long v);
FGLLANG void retint(int);
FGLLANG void retshort(short);
FGLLANG void retlong(long);
FGLLANG void retflo(float*);
FGLLANG void retdub(double*);
FGLLANG void retdec(dec_t *);
FGLLANG void retquote(char*);
FGLLANG void retvchar(char*);

FGLLANG void pushdate(long v);
FGLLANG void pushdec(dec_t* val,unsigned decp);
FGLLANG void pushint(int v);
FGLLANG void pushlong(long v);
FGLLANG void pushshort(short v);
FGLLANG void pushflo(float* v);
FGLLANG void pushdub(double* v);
FGLLANG void pushquote(char* val,int l);
FGLLANG void pushvchar(char* val,int l);
FGLLANG void pushdtime(dtime_t*);

#define CC5(a,b,c,d,e) a##b##c##d##e
#define CC3(a,b,c,d,e) a##b##c
/*#define CFACE(n,a,r) int CC5(n,_,a,_,r) (int nArgs) { return n(nArgs);  }*/
#define CFACE(n,a,r)   CFACE_R(n,a)
#define CFACE_R(n,a)   int CC3(n,_,a,_,r) (int nArgs) { return n(nArgs);  }
#define CNAME(name)    C_##name

#define FGLCALL(fctname,n,a) fctname##_##n(n)

#endif
